﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Datastream.DswsApi;

namespace SampleCode.DswsApi.Net40
{
    /// <summary>
    /// Contains sample code related to initialization
    /// </summary>
    internal class Initialize
    {
        #region Members

        public void APIOptions_Config()
        {
            // The API options are picked automatically from your application configuration file
            // Your config file can be app.config or web.config or anything else customized in your AppDomain setup

            // Here is an example of a configuration you will set up:
            // <appSettings>
            //  <!-- Make sure you set your datastream credentials either here or by setting the relevant properties of the DSApiOptions class (using DSClient.Options) -->
            //  <add key="DswsApi.UserName" value=""/>
            //  <add key="DswsApi.Password" value=""/>
            // </appSettings>

            // Note that there are many other items you can configure 
            // such as EndPointType, ServiceUri, EndPointBehaviors etc

            // Optionally call init
            DSClient.Init();

        } //end APIOptions_Config



        public void APIOptions_Code()
        {
            // Configuration API options
            // Make sure you set your datastream credentials either in the app.config file or by setting the relevant properties of the DSApiOptions class (using DSClient.Options)
            /*
            DSClient.Options.UserName = "";
            DSClient.Options.Password = "";
            */

            // Note that there are many other items you can configure 
            // such as EndPointType, ServiceUri, EndPointBehaviors etc

            // Optionally call init
            DSClient.Init();

        } //end APIOptions_Code



        public void API_Tracing_Config()
        {
            // You can configure tracing for the API
            // This can be done either through config file or through code
            // You can use any class that derives from System.Diagnostics.TraceListener

            // Configure info level tracing thro' config
            // Edit your config file to include this section
            // <system.diagnostics>
            //  <sources>
            //      <source name="DswsApi.TraceSource" switchValue="Information">
            //         <listeners>
            //             <add name="fileListener" 
            //                  type="System.Diagnostics.TextWriterTraceListener" 
            //                  initializeData="C:\DswsApiLog.txt" />
            //         </listeners>
            //     </source>
            //  </sources>
            // </system.diagnostics>


        } //end API_Tracing_Config

        public void API_Tracing_Code()
        {
            // You can configure tracing for the API
            // This can be done either through code or through config file
            // You can use any class that derives from System.Diagnostics.TraceListener

            // Configure info level tracing thro' code
            var level = System.Diagnostics.SourceLevels.Information;
            var src = new System.Diagnostics.TextWriterTraceListener(@"C:\DswsApiLog.txt");
            DSClient.Options.Advanced.ConfigureTracing(level, src);


        } //end API_Tracing_Code


        public string Logon()
        {
            // It is NOT needed to explicitly call Logon
            // Obtaining a token is done internally whenever a need arises
            // Hence calling this method is optional

            DSClient.DataService.Logon();
            return DSClient.Options.CurrentTokenValue;


        } //end Logon

        

        #endregion

    }
}
